<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:f="http://xmlns.jcp.org/jsf/core"
                xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                template="/layout/template.xhtml">


    <ui:define name="content">
        <h:panelGrid rendered="#{getPrincipal.loggedIn and getPrincipal.admin}">
            <div>
                <h1>Index for ANS-HL7V2-SIMULATOR-Preference</h1>
            </div>

            <div class="card crud-demo">
                <h:form id="form">
                    <p:growl id="messages" showDetail="true"/>

                    <p:toolbar>
                        <p:toolbarGroup>
                            <p:commandButton value="New" icon="pi pi-plus" actionListener="#{preferenceBean.openNew()}"
                                             update=":dialogs:manage-preference-content"
                                             oncomplete="PF('managePreferenceDialog').show()"
                                             styleClass="ui-button-success" style="margin-right: .5rem">
                                <p:resetInput target=":dialogs:manage-preference-content"/>
                            </p:commandButton>
                        </p:toolbarGroup>

                    </p:toolbar>

                    <p:dataTable id="dt-preferences" widgetVar="dtPreferences" var="preference"
                                 value="#{preferenceBean.getAll()}"
                                 reflow="true" styleClass="preferences-table"
                                 rowKey="#{preference.getId()}" paginator="true" rows="10" rowSelectMode="add"
                                 paginatorPosition="bottom">


                        <p:column headerText="Id">
                            <h:outputText value="#{preference.id}"/>
                        </p:column>
                        <p:column headerText="PreferenceName">
                            <h:outputText value="#{preference.preferenceName}"/>
                        </p:column>
                        <p:column headerText="Classname">
                            <h:outputText value="#{preference.className}"/>
                        </p:column>

                        <p:column headerText="Preference Value">
                            <h:outputText value="#{preference.preferenceValue}"/>
                        </p:column>
                        <p:column headerText="Description">
                            <h:outputText value="#{preference.description}"/>
                        </p:column>
                        <p:column exportable="false">
                            <p:commandButton icon="pi pi-pencil" update=":dialogs:manage-preference-content"
                                             oncomplete="PF('managePreferenceDialog').show()"
                                             styleClass="edit-button rounded-button ui-button-success">
                                <f:setPropertyActionListener value="#{preference}"
                                                             target="#{preferenceBean.selectedPreference}"/>
                                <p:resetInput target=":dialogs:manage-preference-content"/>
                            </p:commandButton>
                            <p:commandButton class="ui-button-warning rounded-button" icon="pi pi-trash"

                                             oncomplete="PF('deletePreferenceDialog').show()">
                                <f:setPropertyActionListener value="#{preference}"
                                                             target="#{preferenceBean.selectedPreference}"/>
                            </p:commandButton>
                        </p:column>

                    </p:dataTable>
                </h:form>

                <h:form id="dialogs">
                    <p:dialog header="Preference Details" showEffect="fade" modal="true"
                              widgetVar="managePreferenceDialog"
                              responsive="true">
                        <p:outputPanel id="manage-preference-content" class="ui-fluid">
                            <p:outputPanel rendered="#{not empty preferenceBean.selectedPreference}">
                                <div class="field">
                                    <p:outputLabel for="preferenceName">Preference Name</p:outputLabel>
                                    <p:inputText id="preferenceName" value="#{preferenceBean.preferenceName}"
                                    />
                                </div>
                                <div class="field">
                                    <p:outputLabel for="className">Class Name</p:outputLabel>
                                    <p:inputText id="className" value="#{preferenceBean.className}"
                                    />
                                </div>
                                <div class="field">
                                    <p:outputLabel for="preferenceValue">Preference Value</p:outputLabel>
                                    <p:inputText id="preferenceValue" value="#{preferenceBean.preferenceValue}"
                                    />
                                </div>
                                <div class="field">
                                    <p:outputLabel for="description">Description</p:outputLabel>
                                    <p:inputText id="description" value="#{preferenceBean.description}"
                                    />
                                </div>

                            </p:outputPanel>
                        </p:outputPanel>
                        <f:facet name="footer">
                            <p:commandButton value="Save" icon="pi pi-check"
                                             action="#{preferenceBean.insertUpdateSelectedPreference()}"
                                             update="manage-preference-content"
                            />
                            <p:commandButton value="Cancel" icon="pi pi-times"
                                             onclick="PF('managePreferenceDialog').hide()"
                                             class="ui-button-secondary" type="button"/>
                        </f:facet>
                    </p:dialog>

                    <p:confirmDialog widgetVar="deletePreferenceDialog" showEffect="fade" width="300"
                                     message="Delete the preference?" header="Confirm" severity="warn">
                        <p:commandButton value="Yes" icon="pi pi-check"
                                         actionListener="#{preferenceBean.deleteSelectedPreference()}"
                                         oncomplete="PF('deletePreferenceDialog').hide()"
                                         update="@this"/>
                        <p:commandButton value="No" type="button" styleClass="ui-button-secondary" icon="pi pi-times"
                                         onclick="PF('deletePreferenceDialog').hide()"/>
                    </p:confirmDialog>

                    <p:confirmDialog global="true" showEffect="fade" width="300">
                        <p:commandButton value="Yes" type="button" styleClass="ui-confirmdialog-yes"
                                         icon="pi pi-check"/>
                        <p:commandButton value="No" type="button" styleClass="ui-confirmdialog-no ui-button-secondary"
                                         icon="pi pi-times"/>
                    </p:confirmDialog>
                </h:form>
            </div>

        </h:panelGrid>

        <h:panelGrid rendered="#{not getPrincipal.admin}">
                <h:panelGrid styleClass="gzl-mr-3rem gzl-ml-3rem gzl-align-center ">
                    <h1 class="bold">Erreur 403</h1>
                    <h2 class="bold">Accès interdit !</h2>
                    <h:graphicImage
                            styleClass="center-block img-responsive gzl-splash-error gzl-mt-3rem gzl-mb-3rem mw-100"
                            name="resources/images/ihe.png" tooltip="IHE GAZELLE" tooltipPosition="left"/>
                    <p><a class="btn btn-default btn-lg" href="/hl7v2-simulators">Retourner à l'accueil</a></p>
                </h:panelGrid>
        </h:panelGrid>
    </ui:define>

</ui:composition>
